

#ifndef LINK_H
#define LINK_H

#include "q.h"
#include "eventdefs.h"
#include "component.h"
#include "log.h"
#include "comptypes.h"
#include "pdu.h"
#include "event.h"
#include "route.h"
#include "subr.h"
#include "sim_tk.h"


typedef struct _LINKConnectiont{
   struct _LINKConnectiont *cn_next, *cn_prev;
   short         cn_class;
   short         cn_type;
   char          cn_name[40];    /* Name of component (appears on screen) */
   PFP           cn_action;      /* Main function of component.  */
   XComponent    *cn_picture;    /* Graphics object that displays this thing */
   list          *cn_neighbors;  /* List of neighbors of this thing */

   /* Parameters-- data that will be displayed on screen */
   short         cn_menu_up;     /* If true, then the text window is up */
   short         cn_big_menu;    /* not used */
   queue         *cn_params;     /* Variable-length queue of parameters */

   int           cn_iq_length;   /* get the current input q length here */
   int           cn_iq_limit;    /* get the current input q length here */


   int           cn_flash;

   /* parameters -- data that will be logged */
   Param         *cn_Name;
   Param         *cn_delay;
   Param         *cn_mode;
   Param         *cn_err;

   /* assistant variables for this component */
   int           having_data;   /* show if the link contains a bit or not*/ 

} LINKConnectiont;

caddr_t link_action(Component *src, LINKConnectiont *cn, int type, PDU_TYPE *pdu, caddr_t arg);

#endif
  
