#ifndef PDU_H
#define PDU_H


#include <sys/types.h>
#include <stdio.h>
 
#define INTSIZE   sizeof(int)
#define DATASIZE  2              /* maximum length          */

/* The following are the types of messages communicated between 
 * node and links of Token Ring.
 */

/* ---------- PDU Definition (Used in Token Ring Labs) ----- */
typedef struct {
     int  snode;                    /* source node address      */
     int  dnode;                    /* destination node address */
     char data;                     /* message                  */
     char type;                     /* token or frame           */
     int  rs_value;
     int  ps_value;                 /* this two values are here just 
				       for simplicity          */
} PDU_TYPE;

#define PDU_SIZE sizeof(PDU_TYPE)

int pdu_init(); /* Initialize the pool of packets. Returns 0 for failure. */
PDU_TYPE *pdu_alloc();         /* Allocates a packet and returns a pointer
				  thereto.  The packet is guaranteed to contain
				  garbage. */
void pdu_free(PDU_TYPE *pdu);  /* Passed a packet pointer, frees it. */

/**************************************************************************/

#endif   /* PDU_H   */





