

/*
   $Log: sim_tk.C,v $
   Revision 1.2  1997/05/11 14:42:34  shihwei
   rewrite show_neighbor_relation for PNNI. (adding level parameter)

   Revision 1.1  1997/05/11 06:09:58  shihwei
   Initial revision

   */

/* Tk inclusion for CISE -- tlin@cis  */

#include "cisePort.h"
extern "C" {
#include "sim.h"
#include "list.h"
#include "main.h"
#include "component.h"
#include "sim_tk.h"
#include "../components.src/node.h"
}


XComponent* make_icon(Component *co, char *type, int x, int y)
{
    char       buf[100];
    XComponent *xc=(XComponent*)sim_malloc(sizeof(XComponent));
    
    xc->x=x; xc->y=y; 
    xc->w=xc->h=10;

    if ((M.show_links == 0) && strcmp(type, "link")==0) 
      return xc;

    sprintf(buf, "make_icon %s %s %d %d", co->co_name, type, x, y);
    Tcl_Eval(M.interp, buf);
   

    return xc;
}

XComponent* icon_link(Component *co, int x, int y)
{
  if (M.show_links == 1) {     
    display_window(co, x, y);
  }
    return make_icon(co, "link", x, y);
  
  return NULL;
}

XComponent* icon_node(Component *co, int x, int y)
{
  
    display_window(co, x, y);
    draw_node_stack(co, x, y);
  
    draw_adapter(co, x, y);
    return make_icon(co, "node", x, y);
    
}



int show_neighbor_relation(Component *c1, Component *c2)
{
	 return 0;
}


int draw_adapter(Component *c, int x, int y)
{
  
  char buf[200];

  sprintf(buf, "show_neighbor_relation %d %d %d %d %s %s", 
	  x, y, M.center_x, M.center_y, c->co_name, "token_ring_center");
  Tcl_Eval(M.interp, buf);
  
  return 0;
}

int draw_node_stack(Component *c, int x, int y)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  /* monitor_mode has no stacks */
  if (M.monitor_mode) return 0;

  /* priority mode has pritority stack */
  if (M.priority_mode) 
    sprintf(buf, "draw_pri_stack %s %d %d", c->co_name, x, y);

  /* basic mode has destination stack */
  sprintf(buf, "draw_dest_stack %s %d %d", c->co_name, x, y);

  Tcl_Eval(M.interp, buf);

  return 0;
}

int display_elements_in_stack(Component *c, int num)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if (M.monitor_mode) return 0;

  sprintf(buf, "display_elements_in_stack %s %d %d %d", c->co_name, xc->x, xc->y, num);
  Tcl_Eval(M.interp, buf);
  
  return 0;
}

/*
 * push_dest_element()
 *
 * the function will push element with priority on the top of  the stack associated 
 * with Component *c.
 * the visual effect of the function is showing one more element with priority on the 
 * screen like this:
 *
 *  |  |  push_element_in_stack(*, 5)      |5 |
 *  |10|  ===========================>     |10|
 *  |8 |                                   |8 |
 *  ----                                   ----
 *
 */
int push_dest_element(Component *c, int dest)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if (M.monitor_mode) return 0;

  sprintf(buf, "push_dest_element %s %d %d %d", c->co_name, xc->x, xc->y, dest);
  Tcl_Eval(M.interp, buf);
  
  return 0;
}

/*
 * pop_dest_element()
 *
 * the function will pop element  on the top of  the stack associated 
 * with Component *c.
 * the visual effect looks like this:
 *
 *  |5  |  pop_element_in_stack()          |  |
 *  |10|  ===========================>     |10|
 *  |8 |                                   |8 |
 *  ----                                   ----
 *
 */
int pop_dest_element(Component *c)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if (M.monitor_mode) return 0;

  sprintf(buf, "pop_dest_element %s %d %d", c->co_name, xc->x, xc->y);
  Tcl_Eval(M.interp, buf);
  
  return 0;
}
/*
 * Tool for manipulate priority stack
 */
int push_pri_element(Component *c, int pri)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if (M.monitor_mode) return 0;

  if (M.priority_mode)
    sprintf(buf, "push_pri_element %s %d %d %d", c->co_name, xc->x, xc->y, pri);
  Tcl_Eval(M.interp, buf);
  
  return 0;
}

int pop_pri_element(Component *c)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if (M.monitor_mode) return 0;
  if (M.priority_mode) 
    sprintf(buf, "pop_pri_element %s %d %d", c->co_name, xc->x, xc->y);
  Tcl_Eval(M.interp, buf);
  
  return 0;
}


int display_window(Component *c, int x, int y)
{
  char buf[200];
 
  if (M.monitor_mode) return 0;

  sprintf(buf, "display_window %s %d %d", c->co_name, x, y);
  Tcl_Eval(M.interp, buf);

  return 0;
}

int display_number_in_window(Component *c, int num)
{
  char buf[200];
  XComponent *xc=c->co_picture;

  if ((M.show_links == 0)&&(strncmp(c->co_name, "link", 4)==0)) 
      return 0;

  if (M.monitor_mode) return 0; 

  sprintf(buf, "display_number_in_window %s %d %d %d", c->co_name, xc->x, xc->y, num);
  Tcl_Eval(M.interp, buf);

  return 0;
  
}

int delete_num_in_window(Component *c)
{
  char buf[200];
  
  if (M.monitor_mode) return 0;

  sprintf(buf, "delete_number_in_window %s", c->co_name);
  Tcl_Eval(M.interp, buf);

  return 0;
}

int show_token_ring(char *args)
{
  char buf[200], key[32];
  int  x, y, semi_dia;

  sscanf(args, "%s%d%d%d", key, &x, &y, &semi_dia);

  // keep center of token_ring in M 
  M.center_x = x;
  M.center_y = y;
  
  sprintf(buf, "show_token_ring %d %d %d", x, y, semi_dia);
  Tcl_Eval(M.interp, buf);

  return 0;
}


int display_token_ring_status(int type, int num) 
{
  char buf[200];

  switch (type) {
  case TOKEN:
    sprintf(buf, "display_token_ring_status %s %d", "token", num);
    break;
  case FRAME:
    sprintf(buf, "display_token_ring_status %s %d", "frame", num);
    break;
  case PRG:
    sprintf(buf, "display_token_ring_status %s %d", "prg", num);
    break;
  case CT:
    sprintf(buf, "display_token_ring_status %s %d", "ct", num);
    break;
  case AMP:
    sprintf(buf, "display_token_ring_status %s %d", "amp", num);
    break;
  case EMPTY:
    sprintf(buf, "display_token_ring_status %s %d", "empty", num);
    break;
  default:			// should not be here
    printf("Error: display_token_ring_status(%d)\n", type);
    break;
  }
  
  Tcl_Eval(M.interp, buf);

  return 0;
}


int show_token_ring_status_win(char *args)
{
  char buf[200], key[32];
  int  x, y;

  sscanf(args, "%s%d%d", key, &x, &y);

    
  sprintf(buf, "show_token_ring_status_win +%d+%d ", x, y);
  Tcl_Eval(M.interp, buf);

  return 0;
}


int show_info(char *name, char *info)
{
  char buf[200];

  sprintf(buf, "show_info %s %s", name, info);
  Tcl_Eval(M.interp, buf);

  return 0;
}


int show_mesg( char *mesg)
{
  char buf[200];
  static char str[200];

  strcpy(str, mesg); 
  
  sprintf(buf, "show_mesg \"%s\n\"", mesg);
  
  Tcl_Eval(M.interp, buf);

  return 0;
}

int delete_mesg()
{
  char buf[200];
  
  sprintf(buf, "delete_mesg");
  Tcl_Eval(M.interp, buf);

  return 0;
}

int make_notefoot()
{
  char buf[200];
  sprintf(buf, "make_notefoot");
  Tcl_Eval(M.interp, buf);

  return 0;
}

int show_who_is_monitor(char *name)
{
  char buf[200];
  sprintf(buf, "show_who_is_monitor %s", name);
  Tcl_Eval(M.interp, buf);

  return 0;
}







