

/*
   $Log: sim_tk.h,v $
   Revision 1.4  1997/05/11 14:44:55  shihwei
   rewrite show_neighbor_relation() for PNNI

   Revision 1.3  1997/05/11 01:16:48  shihwei
   change name: _level -> _pos_in_level
   	     level[] -> pos_in_level[]

   Revision 1.2  1997/05/11 01:07:04  shihwei
   add struct _level, add _level into XComponent

   Revision 1.1  1997/05/11 01:02:16  shihwei
   Initial revision

   Revision 4.0  1996/08/23 20:02:27  tlin
   bump to mickey mouse version

   Revision 1.6  1996/06/03 00:45:48  tlin
   neighbor relationship is shown on canvas

   Revision 1.5  1996/06/02 17:51:04  tlin
   workaable, phase 1

   Revision 1.4  1996/06/01 05:48:36  tlin
   add char *name to icon_xxx()

   Revision 1.3  1996/06/01 02:23:22  tlin
   function without body is ready

   Revision 1.2  1996/06/01 01:53:24  tlin
   foo

   Revision 1.1  1996/06/01 01:46:25  tlin
   Initial revision

   
   */

/* Tk inclusion for CISE -- tlin@cis  */

#ifndef SIM_TK_H
#define SIM_TK_H

typedef struct {
  int x, y, w, h;
} _pos_in_level;

typedef struct {
    Component *scomponent;
    int x, y, w, h;
} XComponent;


XComponent* icon_link(Component *co, int x, int y);
XComponent* icon_node(Component *co, int x, int y);

int show_neighbor_relation(Component *c1, Component *c2);

/* token-ring stuff */
int draw_node_stack(Component *c, int x, int y);
int display_elements_in_stack(Component *c, int num);
int push_dest_element(Component *c, int dest);
int pop_dest_element(Component *c);
int push_pri_element(Component *c, int pri);
int pop_pri_element(Component *c);
int display_window(Component *c, int x, int y);
int display_number_in_window(Component *c, int num);
int delete_num_in_window(Component *c);
int show_token_ring(char *args);
int display_token_ring_status(int type, int num);
int draw_adapter(Component *c, int x, int y);
int show_token_ring_status_win(char *args);
/*
        int show_info(char *name, char *info);
	  
	    Use this function to show the information on the token ring 
                  status window.
	        name must be one of them: "src", "dest", "ppp", "rrr", 
                     "aa", "cc", "monitor".
		info could be any string which you want to show.

		        ex: show_info("src", "node1")


	 int show_mesg( char *mesg);

	     Use this function to show message on the token status window.
		
	        
	 int delete_mesg();

	     If you need to change the message. You need to use this function 
             before you call show_mesg(). 
             Otherwise, the old mesg won't be removed, 
	     New mesg will be appended after the Old mesg.
 
*/
int show_info(char *name, char *info);
int show_mesg( char *mesg);
int delete_mesg();
int make_notefoot();
int show_who_is_monitor(char *name);









#endif
